//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  list<int> coll;

  INSERT_ELEMENTS(coll,1,6);
  PRINT_ELEMENTS(coll," :\n");

  //    
  //  (0 + 1*1 + 2*2 + 3*3 + 4*4 + 5*5 + 6*6)
  cout << ToRus(" (0 + 1*1 + 2*2 + 3*3 + 4*4 + 5*5 + 6*6): ")
       << inner_product (coll.begin(), coll.end(),  //  
                         coll.begin(),              //  
                         0)                         //  
       << endl;

  //   1*6 ... 6*1
  //   (0 + 1*6 + 2*5 + 3*4 + 4*3 + 5*2 + 6*1)
  cout << ToRus(" (0 + 1*6 + 2*5 + 3*4 + 4*3 + 5*2 + 6*1): ")
       << inner_product (coll.begin(), coll.end(),  //  
                         coll.rbegin(),             //  
                         0)                         //  
       << endl;

  //    
  //  (1 * 1+1 * 2+2 * 3+3 * 4+4 * 5+5 * 6+6)
  cout << ToRus(" (1 * 1+1 * 2+2 * 3+3 * 4+4 * 5+5 * 6+6): ")
       << inner_product (coll.begin(), coll.end(),  //  
                         coll.begin(),              //  
                         1,                         //  
                         multiplies<int>(),         //  
                         plus<int>())               //  
       << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------